// QSOXTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "QSOXTest.h"
#include "QSOXTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CQSOXTestDlg dialog

CQSOXTestDlg::CQSOXTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CQSOXTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CQSOXTestDlg)
	m_bAutoStopTX = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CQSOXTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CQSOXTestDlg)
	DDX_Check(pDX, IDC_AUTOSTOPTX, m_bAutoStopTX);
	DDX_Control(pDX, IDC_RXCONTROLCTRL1, m_ctlRXCtl);
	DDX_Control(pDX, IDC_TXCONTROLCTRL1, m_ctlTXCtl);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CQSOXTestDlg, CDialog)
	//{{AFX_MSG_MAP(CQSOXTestDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_XMIT, OnXmit)
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CQSOXTestDlg message handlers

BOOL CQSOXTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	m_ctlTXCtl.SetMyCall ( "WA0TTN" ) ;
	//m_ctlTXCtl.SetForeColor ( RGB(0, 255, 255) ) ;
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CQSOXTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CQSOXTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CQSOXTestDlg::OnXmit() 
{
	if ( m_ctlRXCtl.GetQSOMode() )
	{
		m_ctlRXCtl.SetQSOMode ( FALSE ) ;
		KillTimer ( 1 ) ;
		GetDlgItem(IDC_XMIT)->SetWindowText("Xmit");
	}
	else
	{
		m_ctlRXCtl.SetQSOMode ( TRUE ) ;
		SetTimer ( 1, 200, NULL ) ;
		GetDlgItem(IDC_XMIT)->SetWindowText("StopTX");
	}
	
}

void CQSOXTestDlg::OnTimer(UINT nIDEvent) 
{
	UpdateData(true);

	long NextChar = m_ctlTXCtl.NextChar() ;
	if ( NextChar > 0 )
	{
		m_ctlRXCtl.AddChar ( NextChar ) ;
	}
	else if ( m_bAutoStopTX )
	{
		m_ctlRXCtl.SetQSOMode ( FALSE ) ;
		KillTimer ( 1 ) ;
		GetDlgItem(IDC_XMIT)->SetWindowText("Xmit");
	}
	
	CDialog::OnTimer(nIDEvent);
}
